package com.myapp.core;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Collections;
import java.util.List;
import java.util.Vector;



public class JdbcDAO implements DAO {
	
	private Connection connection;
	
	public JdbcDAO() {
		// create database connection
		try {
			Class.forName("org.hsqldb.jdbcDriver" );
			connection = DriverManager.getConnection("jdbc:hsqldb:file:db/mydb", "sa", "");
			checkTables();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	public List<User> getUsers() {
		List<User> result = new Vector<User>();
		try {
			Statement st = connection.createStatement();
			ResultSet rs = st.executeQuery("SELECT * FROM users");
			while(rs.next()) {
				User u = new User(rs.getString("login"), rs.getString("password"));
				result.add(u);
			}
			rs.close();
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return Collections.unmodifiableList(result);
	}
	
	/**
	 * Check if the users table exits. If not create the table and insert a default user.
	 * @throws SQLException
	 */
	private void checkTables() throws SQLException {
		DatabaseMetaData dbmd = connection.getMetaData();
		ResultSet rs = dbmd.getTables(null, null, "users", null);
		// if we have an empty resultset it means that the table doesn't exist
		if(!rs.next()) {
			Statement st = connection.createStatement();
			st.execute("CREATE TABLE users (login varchar(255), password varchar(255))");
			st.close();
			
			// now store some default user
			PreparedStatement pst = connection.prepareStatement("INSERT INTO users (login, password) values (?, ?)");
			pst.setString(1, "myuser");
			pst.setString(2, "mypasswd");
			pst.executeUpdate();
			pst.close();
		}
		rs.close();
	}

}
